/* SPDX-License-Identifier: GPL-2.0 WITH Linux-syscall-note */
/*
 *
 * (C) COPYRIGHT 2018-2021 ARM Limited. All rights reserved.
 *
 * This program is free software and is provided to you under the terms of the
 * GNU General Public License version 2 as published by the Free Software
 * Foundation, and any use by you of this program is subject to the terms
 * of such GNU license.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, you can access it online at
 * http://www.gnu.org/licenses/gpl-2.0.html.
 *
 */

/*
 * This header was originally autogenerated, but it is now ok (and
 * expected) to have to add to it.
 */

#ifndef _UAPI_GPU_CSF_REGISTERS_H_
#define _UAPI_GPU_CSF_REGISTERS_H_

/* Only user block defines are included. HI words have been removed */

/* CS_USER_INPUT_BLOCK register offsets */
#define CS_INSERT 0x0000 /* () Current insert offset for ring buffer, low word */
#define CS_EXTRACT_INIT 0x0008 /* () Initial extract offset for ring buffer, low word */

/* CS_USER_OUTPUT_BLOCK register offsets */
#define CS_EXTRACT 0x0000 /* () Current extract offset for ring buffer, low word */
#define CS_ACTIVE 0x0008 /* () Initial extract offset when the CS is started */

/* USER register offsets */
#define LATEST_FLUSH 0x0000 /* () Flush ID of latest clean-and-invalidate operation */

#endif
